// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'treelist.pas' rev: 3.00

#ifndef treelistHPP
#define treelistHPP
#include <Commctrl.hpp>
#include <ExtCtrls.hpp>
#include <ComCtrls.hpp>
#include <Mask.hpp>
#include <Clipbrd.hpp>
#include <StdCtrls.hpp>
#include <Dialogs.hpp>
#include <Forms.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Treelist
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS TColumnItem;
class PASCALIMPLEMENTATION TColumnItem : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	int fWidth;
	TAlignment fAlignment;
	System::AnsiString fColumnHeader;
	Graphics::TFont* fFont;
	bool fImage;
	TAlignment fHeaderAlign;
	int fHeaderImage;
	void __fastcall SetWidth(const int value);
	void __fastcall SetAlignment(const Classes::TAlignment value);
	void __fastcall SetColumnHeader(const System::AnsiString value);
	void __fastcall SetFont(const Graphics::TFont* value);
	void __fastcall SetImage(const bool Value);
	void __fastcall SetHeaderAlign(const Classes::TAlignment Value);
	void __fastcall SetHeaderImage(const int Value);
	
public:
	__fastcall virtual TColumnItem(Classes::TCollection* Collection);
	__fastcall virtual ~TColumnItem(void);
	virtual void __fastcall Assign(Classes::TPersistent* source);
	
__published:
	__property Classes::TAlignment Alignment = {read=fAlignment, write=SetAlignment, default=0};
	__property Graphics::TFont* Font = {read=fFont, write=SetFont};
	__property System::AnsiString Header = {read=fColumnHeader, write=SetColumnHeader};
	__property Classes::TAlignment HeaderAlign = {read=fHeaderAlign, write=SetHeaderAlign, default=0};
	__property int HeaderImage = {read=fHeaderImage, write=SetHeaderImage, default=-1};
	__property bool Image = {read=fImage, write=SetImage, default=0};
	__property int Width = {read=fWidth, write=SetWidth, nodefault};
};

class DELPHICLASS TColumnCollection;
class DELPHICLASS TTreeList;
class DELPHICLASS TTLHeader;
typedef void __fastcall (__closure *TTLHeaderClickEvent)(System::TObject* Sender, int SectionIdx);

class PASCALIMPLEMENTATION TTLHeader : public Extctrls::THeader 
{
	typedef Extctrls::THeader inherited;
	
private:
	Graphics::TColor fColor;
	TTLHeaderClickEvent fOnClick;
	TTLHeaderClickEvent fOnRightClick;
	HIDESBASE MESSAGE void __fastcall WMLButtonDown(Messages::TWMMouse &Message);
	HIDESBASE MESSAGE void __fastcall WMRButtonDown(Messages::TWMMouse &Message);
	HIDESBASE void __fastcall SetColor(const Graphics::TColor Value);
	
public:
	__fastcall virtual TTLHeader(Classes::TComponent* aOwner);
	
protected:
	virtual void __fastcall Paint(void);
	
__published:
	__property Graphics::TColor Color = {read=fColor, write=SetColor, nodefault};
	__property TTLHeaderClickEvent OnClick = {read=fOnClick, write=fOnClick};
	__property TTLHeaderClickEvent OnRightClick = {read=fOnRightClick, write=fOnRightClick};
public:
	/* THeader.Destroy */ __fastcall virtual ~TTLHeader(void) { }
	
public:
	/* TWinControl.CreateParented */ __fastcall TTLHeader(HWND ParentWindow) : Extctrls::THeader(ParentWindow
		) { }
	
};

class DELPHICLASS THeaderSettings;
class PASCALIMPLEMENTATION THeaderSettings : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	TTreeList* fOwner;
	int fHeight;
	Graphics::TFont* __fastcall GetFont(void);
	void __fastcall SetFont(const Graphics::TFont* Value);
	bool __fastcall GetFlat(void);
	void __fastcall SetFlat(const bool Value);
	bool __fastcall GetAllowResize(void);
	void __fastcall SetAllowResize(const bool Value);
	Graphics::TColor __fastcall GetColor(void);
	void __fastcall SetColor(const Graphics::TColor Value);
	int __fastcall GetHeight(void);
	void __fastcall SetHeight(const int Value);
	
public:
	__fastcall THeaderSettings(TTreeList* aOwner);
	
__published:
	__property bool AllowResize = {read=GetAllowResize, write=SetAllowResize, nodefault};
	__property Graphics::TColor Color = {read=GetColor, write=SetColor, nodefault};
	__property bool Flat = {read=GetFlat, write=SetFlat, nodefault};
	__property Graphics::TFont* Font = {read=GetFont, write=SetFont};
	__property int Height = {read=GetHeight, write=SetHeight, nodefault};
public:
	/* TPersistent.Destroy */ __fastcall virtual ~THeaderSettings(void) { }
	
};

class PASCALIMPLEMENTATION TTreeList : public Comctrls::TTreeView 
{
	typedef Comctrls::TTreeView inherited;
	
private:
	TTLHeader* fHeader;
	THeaderSettings* fHeaderSettings;
	bool fFlatHeader;
	TColumnCollection* fColumnCollection;
	bool fColumnLines;
	int fColumnSpace;
	int fOldScrollPos;
	System::AnsiString fSeparator;
	int fItemHeight;
	TTLHeaderClickEvent fOnClick;
	TTLHeaderClickEvent fOnRightClick;
	HIDESBASE MESSAGE void __fastcall WMHScroll(Messages::TMessage &message);
	HIDESBASE MESSAGE void __fastcall WMLButtonDown(Messages::TWMMouse &message);
	HIDESBASE MESSAGE void __fastcall WMPaint(Messages::TWMPaint &message);
	HIDESBASE MESSAGE void __fastcall CNNotify(Messages::TWMNotify &message);
	void __fastcall SetColumnCollection(const TColumnCollection* Value);
	void __fastcall SetColumnLines(const bool Value);
	void __fastcall UpdateColumns(void);
	void __fastcall SectionSize(System::TObject* sender, int ASection, int AWidth);
	void __fastcall HeaderClick(System::TObject* sender, int ASection);
	void __fastcall HeaderRightClick(System::TObject* sender, int ASection);
	bool __fastcall GetColImage(int idx);
	int __fastcall GetColWidth(int idx);
	Graphics::TFont* __fastcall GetColFont(int idx);
	int __fastcall GetAlignment(int idx);
	void __fastcall SetSeparator(const System::AnsiString Value);
	int __fastcall GetItemHeight(void);
	void __fastcall SetItemHeight(const int Value);
	bool __fastcall GetVisible(void);
	HIDESBASE void __fastcall SetVisible(const bool Value);
	
protected:
	virtual void __fastcall CreateWnd(void);
	virtual void __fastcall DestroyWnd(void);
	virtual Windows::TRect __fastcall GetClientRect();
	
public:
	__fastcall virtual TTreeList(Classes::TComponent* aOwner);
	__fastcall virtual ~TTreeList(void);
	virtual void __fastcall SetBounds(int ALeft, int ATop, int AWidth, int AHeight);
	void __fastcall SetNodeColumn(Comctrls::TTreeNode* tn, int idx, System::AnsiString value);
	System::AnsiString __fastcall GetNodeColumn(Comctrls::TTreeNode* tn, int idx);
	
__published:
	__property TColumnCollection* Columns = {read=fColumnCollection, write=SetColumnCollection};
	__property bool ColumnLines = {read=fColumnLines, write=SetColumnLines, nodefault};
	__property System::AnsiString Separator = {read=fSeparator, write=SetSeparator};
	__property int ItemHeight = {read=GetItemHeight, write=SetItemHeight, nodefault};
	__property TTLHeaderClickEvent OnHeaderClick = {read=fOnClick, write=fOnClick};
	__property TTLHeaderClickEvent OnHeaderRightClick = {read=fOnRightClick, write=fOnRightClick};
	__property bool Visible = {read=GetVisible, write=SetVisible, nodefault};
	__property THeaderSettings* HeaderSettings = {read=fHeaderSettings, write=fHeaderSettings};
public:
	/* TWinControl.CreateParented */ __fastcall TTreeList(HWND ParentWindow) : Comctrls::TTreeView(ParentWindow
		) { }
	
};

class PASCALIMPLEMENTATION TColumnCollection : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
private:
	TTreeList* fOwner;
	
protected:
	virtual void __fastcall Update(Classes::TCollectionItem* Item);
	
public:
	__fastcall TColumnCollection(TTreeList* aOwner);
	DYNAMIC Classes::TPersistent* __fastcall GetOwner(void);
public:
	/* TCollection.Destroy */ __fastcall virtual ~TColumnCollection(void) { }
	
};

//-- var, const, procedure ---------------------------------------------------

}	/* namespace Treelist */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Treelist;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// treelist
